//+------------------------------------------------------------------+
//| ADX .mq4 
//| Amir
//+------------------------------------------------------------------+
#property  copyright "Author - Amir"
//----
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 White
#property indicator_width1 1
#property indicator_width2 1
//---- input parameters
extern int    ADXbarsPeriod       = 2;
extern bool   UseADX_level        = true;
extern int    ADX_level_Threshold = 99;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert.wav";
//---- buffers
double val1[];
double val2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
return(0);
}
//+------------------------------------------------------------------+
//| AltrTrend_Signal_v2_2                                            |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int shift,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for (shift = limit; shift >= 0; shift--)
   {
      double b4plusdi   = iADX(NULL,0,ADXbarsPeriod,PRICE_CLOSE,MODE_PLUSDI, shift+1);
      double nowplusdi  = iADX(NULL,0,ADXbarsPeriod,PRICE_CLOSE,MODE_PLUSDI, shift);
      double b4minusdi  = iADX(NULL,0,ADXbarsPeriod,PRICE_CLOSE,MODE_MINUSDI,shift+1);
      double nowminusdi = iADX(NULL,0,ADXbarsPeriod,PRICE_CLOSE,MODE_MINUSDI,shift);
      double b4adxmain  = iADX(NULL,0,ADXbarsPeriod,PRICE_CLOSE,MODE_MAIN,   shift+1);
      double nowadxmain = iADX(NULL,0,ADXbarsPeriod,PRICE_CLOSE,MODE_MAIN,   shift);
 
   val1[shift] = EMPTY_VALUE;
   val2[shift] = EMPTY_VALUE;
   if   (UseADX_level) 
     {
      if (b4plusdi<b4minusdi && nowplusdi>nowminusdi  &&  nowadxmain >= ADX_level_Threshold)
         
         val1[shift]=Low[shift]-5*Point;
         
       if (b4adxmain < ADX_level_Threshold && nowadxmain > ADX_level_Threshold && nowplusdi>nowminusdi)
         
         val1[shift]=Low[shift]-5*Point;
            
         
      if (b4plusdi>b4minusdi && nowplusdi<nowminusdi  &&  nowadxmain >= ADX_level_Threshold)
       val2[shift]=High[shift]+5*Point;
      if (b4adxmain < ADX_level_Threshold && nowadxmain > ADX_level_Threshold && nowplusdi<nowminusdi)
          val2[shift]=High[shift]+5*Point;
         
         
         

 
     } 
   
     else 
      {
      if (b4plusdi<b4minusdi && nowplusdi>nowminusdi)
         {
         val1[shift]=Low[shift]-5*Point;
         }
      if (b4plusdi>b4minusdi && nowplusdi<nowminusdi)
         {
         val2[shift]=High[shift]+5*Point;
         }
       } 
     }
   
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      
      //
      //
      //
      //
      //
      
      if (val1[whichBar+1] == EMPTY_VALUE && val1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"UP");
      if (val2[whichBar+1] == EMPTY_VALUE && val2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"Dn");
    }         
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ADX ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " ADX "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


